
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32A
;Program type             : Application
;Clock frequency          : 8.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : long, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega32A
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2143
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _ac1=R4
	.DEF _ac2=R6
	.DEF _ac3=R8
	.DEF _b1=R10
	.DEF _b2=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x38:
	.DB  0x50
_0x39:
	.DB  0xB0,0x4
_0x3A:
	.DB  0xA
_0x8F:
	.DB  0x11,0x22,0x33,0x44,0x55,0x66
_0x90:
	.DB  0xC0,0xA8,0x1,0xA
_0x92:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
_0x0:
	.DB  0x20,0x54,0x3D,0x20,0x25,0x64,0x2E,0x25
	.DB  0x64,0x20,0x43,0x20,0x20,0x20,0x0,0x20
	.DB  0x50,0x3D,0x20,0x25,0x64,0x25,0x64,0x20
	.DB  0x70,0x61,0x20,0x20,0x20,0x20,0x0,0x53
	.DB  0x61,0x6A,0x61,0x64,0x20,0x53,0x68,0x61
	.DB  0x6D,0x73,0x69,0x0,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x4D,0x41,0x43,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0x20,0x25,0x30
	.DB  0x32,0x78,0x25,0x30,0x32,0x78,0x2D,0x25
	.DB  0x30,0x32,0x78,0x25,0x30,0x32,0x78,0x2D
	.DB  0x25,0x30,0x32,0x78,0x25,0x30,0x32,0x78
	.DB  0x20,0x0,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x49,0x50,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x0,0x25,0x30,0x33,0x75,0x2E
	.DB  0x25,0x30,0x33,0x75,0x2E,0x25,0x30,0x33
	.DB  0x75,0x2E,0x25,0x30,0x33,0x75,0x0,0x54
	.DB  0x3D,0x25,0x75,0x2C,0x50,0x3D,0x25,0x75
	.DB  0x2C,0x25,0x75,0xA,0x0,0x47,0x45,0x54
	.DB  0x20,0x2F,0x0,0x48,0x54,0x54,0x50,0x2F
	.DB  0x31,0x2E,0x30,0x20,0x32,0x30,0x30,0x20
	.DB  0x4F,0x4B,0xD,0xA,0x0,0x43,0x6F,0x6E
	.DB  0x74,0x65,0x6E,0x74,0x2D,0x54,0x79,0x70
	.DB  0x65,0x3A,0x20,0x74,0x65,0x78,0x74,0x2F
	.DB  0x68,0x74,0x6D,0x6C,0xD,0xA,0x0,0x50
	.DB  0x72,0x61,0x67,0x6D,0x61,0x3A,0x20,0x6E
	.DB  0x6F,0x2D,0x63,0x61,0x63,0x68,0x65,0xD
	.DB  0xA,0xD,0xA,0x0,0x3C,0x48,0x54,0x4D
	.DB  0x4C,0x3E,0x3C,0x54,0x49,0x54,0x4C,0x45
	.DB  0x3E,0x20,0x44,0x41,0x4D,0x41,0x20,0x41
	.DB  0x4E,0x44,0x20,0x46,0x45,0x53,0x48,0x41
	.DB  0x52,0x20,0x20,0x3C,0x2F,0x54,0x49,0x54
	.DB  0x4C,0x45,0x3E,0x3C,0x42,0x4F,0x44,0x59
	.DB  0x3E,0x3C,0x43,0x45,0x4E,0x54,0x45,0x52
	.DB  0x3E,0x0,0x3C,0x50,0x3E,0x20,0x53,0x61
	.DB  0x6A,0x61,0x64,0x20,0x53,0x68,0x61,0x6D
	.DB  0x73,0x69,0x20,0x20,0x3C,0x2F,0x50,0x3E
	.DB  0xA,0x3C,0x48,0x52,0x3E,0x0,0x3C,0x50
	.DB  0x3E,0x20,0x3C,0x46,0x4F,0x4E,0x54,0x20
	.DB  0x43,0x4F,0x4C,0x4F,0x52,0x3D,0x23,0x30
	.DB  0x30,0x30,0x30,0x46,0x46,0x3E,0x20,0x0
	.DB  0x3C,0x2F,0x46,0x4F,0x4E,0x54,0x3E,0x3C
	.DB  0x2F,0x50,0x3E,0xA,0x0,0x3C,0x50,0x3E
	.DB  0x3C,0x41,0x20,0x48,0x52,0x45,0x46,0x3D
	.DB  0x22,0x2E,0x22,0x3E,0x72,0x65,0x66,0x72
	.DB  0x65,0x73,0x68,0x3C,0x2F,0x41,0x3E,0x3C
	.DB  0x50,0x3E,0x3C,0x2F,0x43,0x45,0x4E,0x54
	.DB  0x45,0x52,0x3E,0x3C,0x48,0x52,0x3E,0xA
	.DB  0x0
_0x2040003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  _wwwport_G000
	.DW  _0x38*2

	.DW  0x02
	.DW  _udpport_G000
	.DW  _0x39*2

	.DW  0x01
	.DW  _seqnum_G000
	.DW  _0x3A*2

	.DW  0x06
	.DW  _mymac
	.DW  _0x8F*2

	.DW  0x04
	.DW  _myip
	.DW  _0x90*2

	.DW  0x02
	.DW  __base_y_G102
	.DW  _0x2040003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;//--------------------------------------------------------------------------
;// Project              : Transferring Data via Ethernet
;// Author               : Habibollah Abdollahypoor
;// Chip type            : ATmega32
;// Program type         : Application
;// Clock frequency      : 6.250000 MHz
;// Memory model         : Small
;// Data Stack size      : 512
;//--------------------------------------------------------------------------
;#include <mega32a.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <stdio.h>
;#include <string.h>
;#include <delay.h>
;#include <alcd.h>
;#include <i2c.h>
;char temp_to_http_buffer[17],pre_to_http_buffer[17];
; #include "bmp180.h"
    .equ __i2c_port=0x15
    .equ __sda_bit=1
    .equ __scl_bit=0

	.CSEG
_write_to_device:
	CALL SUBOPT_0x0
;	address_register -> Y+1
;	control_register -> Y+0
	LDD  R26,Y+1
	CALL _i2c_write
	LD   R26,Y
	CALL _i2c_write
	CALL _i2c_stop
	RJMP _0x2080011
_read_from_device:
	CALL SUBOPT_0x0
;	address_register -> Y+0
	LD   R26,Y
	CALL _i2c_write
	CALL _i2c_start
	LDI  R26,LOW(239)
	CALL _i2c_write
	LDI  R26,LOW(1)
	CALL _i2c_read
	STS  _data,R30
	LDI  R26,LOW(0)
	CALL _i2c_read
	__PUTB1MN _data,1
	CALL _i2c_stop
	RJMP _0x2080012
_power:
	ST   -Y,R27
	ST   -Y,R26
	CALL __SAVELOCR4
;	i -> Y+6
;	j -> Y+4
;	k -> R16,R17
;	r -> R18,R19
	__GETWRN 16,17,0
	__GETWRN 18,19,1
	__GETWRN 16,17,0
_0x4:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x5
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	MOVW R26,R18
	CALL __MULW12
	MOVW R18,R30
	__ADDWRN 16,17,1
	RJMP _0x4
_0x5:
	MOVW R30,R18
	CALL __LOADLOCR4
	ADIW R28,8
	RET
_calibre:
	LDI  R26,LOW(170)
	CALL SUBOPT_0x1
	MOVW R4,R30
	LDI  R26,LOW(172)
	CALL SUBOPT_0x1
	MOVW R6,R30
	LDI  R26,LOW(174)
	CALL SUBOPT_0x1
	MOVW R8,R30
	LDI  R26,LOW(176)
	CALL SUBOPT_0x1
	STS  _ac4,R30
	STS  _ac4+1,R31
	LDI  R26,LOW(178)
	CALL SUBOPT_0x1
	STS  _ac5,R30
	STS  _ac5+1,R31
	LDI  R26,LOW(180)
	CALL SUBOPT_0x1
	STS  _ac6,R30
	STS  _ac6+1,R31
	LDI  R26,LOW(182)
	CALL SUBOPT_0x1
	MOVW R10,R30
	LDI  R26,LOW(184)
	CALL SUBOPT_0x1
	MOVW R12,R30
	LDI  R26,LOW(186)
	CALL SUBOPT_0x1
	STS  _mb,R30
	STS  _mb+1,R31
	LDI  R26,LOW(188)
	RCALL _read_from_device
	LDS  R31,_data
	LDI  R30,LOW(0)
	CALL __CWD1
	MOVW R26,R30
	MOVW R24,R22
	__GETB1MN _data,1
	LDI  R31,0
	CALL __CWD1
	CALL __ADDD12
	STS  _mc,R30
	STS  _mc+1,R31
	STS  _mc+2,R22
	STS  _mc+3,R23
	LDI  R26,LOW(190)
	CALL SUBOPT_0x1
	STS  _md,R30
	STS  _md+1,R31
	RET
_show_temp:
	LDI  R30,LOW(244)
	ST   -Y,R30
	LDI  R26,LOW(46)
	RCALL _write_to_device
	LDI  R26,LOW(5)
	CALL SUBOPT_0x2
	LDI  R26,LOW(246)
	CALL SUBOPT_0x1
	CALL __CWD1
	STS  _UT,R30
	STS  _UT+1,R31
	STS  _UT+2,R22
	STS  _UT+3,R23
	LDS  R30,_ac6
	LDS  R31,_ac6+1
	LDS  R26,_UT
	LDS  R27,_UT+1
	LDS  R24,_UT+2
	LDS  R25,_UT+3
	CLR  R22
	CLR  R23
	CALL __SUBD21
	LDS  R30,_ac5
	LDS  R31,_ac5+1
	CLR  R22
	CLR  R23
	CALL SUBOPT_0x3
	__GETD1N 0x8000
	CALL SUBOPT_0x4
	LDS  R30,_mc
	LDS  R31,_mc+1
	LDS  R22,_mc+2
	LDS  R23,_mc+3
	__GETD2N 0x800
	CALL __MULD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_md
	LDS  R31,_md+1
	CALL SUBOPT_0x5
	CALL __CWD1
	CALL __ADDD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x6
	STS  _b5,R30
	STS  _b5+1,R31
	STS  _b5+2,R22
	STS  _b5+3,R23
	CALL SUBOPT_0x7
	__ADDD1N 8
	CALL SUBOPT_0x8
	STS  _T,R30
	STS  _T+1,R31
	STS  _T+2,R22
	STS  _T+3,R23
	CALL SUBOPT_0x9
	CALL SUBOPT_0xA
	CALL SUBOPT_0x9
	CALL SUBOPT_0xB
	LDI  R30,LOW(_temp_to_http_buffer)
	LDI  R31,HIGH(_temp_to_http_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,0
	RJMP _0x2080013
_show_pre:
	LDI  R30,LOW(244)
	ST   -Y,R30
	LDI  R26,LOW(52)
	RCALL _write_to_device
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(0)
	LDI  R27,0
	RCALL _power
	ADIW R30,5
	MOVW R26,R30
	CALL _delay_ms
	LDI  R26,LOW(246)
	CALL SUBOPT_0x1
	CALL __CWD1
	STS  _UP,R30
	STS  _UP+1,R31
	STS  _UP+2,R22
	STS  _UP+3,R23
	CALL SUBOPT_0x7
	__SUBD1N 4000
	STS  _b6,R30
	STS  _b6+1,R31
	STS  _b6+2,R22
	STS  _b6+3,R23
	CALL SUBOPT_0xC
	CALL SUBOPT_0xD
	__GETD1N 0x1000
	CALL __DIVD21
	MOVW R26,R12
	CALL SUBOPT_0xE
	__GETD1N 0x800
	CALL SUBOPT_0x4
	CALL SUBOPT_0xC
	MOVW R26,R6
	CALL SUBOPT_0xE
	__GETD1N 0x800
	CALL SUBOPT_0x6
	CALL SUBOPT_0xF
	MOVW R30,R4
	CALL __LSLW2
	MOVW R26,R30
	CALL SUBOPT_0x10
	CALL __CWD2
	CALL __ADDD21
	LDI  R30,LOW(2)
	CALL __LSLD12
	CALL SUBOPT_0x11
	STS  _b3,R30
	STS  _b3+1,R31
	STS  _b3+2,R22
	STS  _b3+3,R23
	CALL SUBOPT_0xC
	MOVW R26,R8
	CALL SUBOPT_0xE
	__GETD1N 0x2000
	CALL SUBOPT_0x4
	CALL SUBOPT_0xC
	CALL SUBOPT_0xD
	__GETD1N 0x2000
	CALL __DIVD21
	MOVW R26,R10
	CALL SUBOPT_0xE
	CALL SUBOPT_0x12
	CALL SUBOPT_0x6
	__ADDD1N 2
	CALL SUBOPT_0x11
	CALL SUBOPT_0xF
	CALL SUBOPT_0x10
	__ADDD1N 32768
	LDS  R26,_ac4
	LDS  R27,_ac4+1
	CLR  R24
	CLR  R25
	CALL __MULD12U
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x8000
	CALL __DIVD21U
	STS  _b4,R30
	STS  _b4+1,R31
	STS  _b4+2,R22
	STS  _b4+3,R23
	LDS  R26,_b3
	LDS  R27,_b3+1
	LDS  R24,_b3+2
	LDS  R25,_b3+3
	LDS  R30,_UP
	LDS  R31,_UP+1
	LDS  R22,_UP+2
	LDS  R23,_UP+3
	CALL __SUBD12
	__GETD2N 0xC350
	CALL __MULD12U
	STS  _b7,R30
	STS  _b7+1,R31
	STS  _b7+2,R22
	STS  _b7+3,R23
	CALL SUBOPT_0x13
	__CPD2N 0x80000000
	BRSH _0x6
	LDS  R30,_b7
	LDS  R31,_b7+1
	LDS  R22,_b7+2
	LDS  R23,_b7+3
	CALL __LSLD1
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x14
	CALL __DIVD21U
	RJMP _0x98
_0x6:
	CALL SUBOPT_0x14
	CALL SUBOPT_0x13
	CALL __DIVD21U
	CALL __LSLD1
_0x98:
	STS  _P,R30
	STS  _P+1,R31
	STS  _P+2,R22
	STS  _P+3,R23
	CALL SUBOPT_0x15
	__GETD1N 0x100
	CALL __DIVD21
	MOVW R26,R30
	MOVW R24,R22
	CALL __MULD12
	STS  _x1,R30
	STS  _x1+1,R31
	STS  _x1+2,R22
	STS  _x1+3,R23
	__GETD2N 0xBDE
	CALL SUBOPT_0x3
	CALL SUBOPT_0x12
	CALL SUBOPT_0x4
	LDS  R30,_P
	LDS  R31,_P+1
	LDS  R22,_P+2
	LDS  R23,_P+3
	__GETD2N 0xFFFFE343
	CALL SUBOPT_0x3
	CALL SUBOPT_0x12
	CALL SUBOPT_0x6
	__ADDD1N 3791
	CALL SUBOPT_0x8
	CALL SUBOPT_0x15
	CALL __ADDD12
	STS  _P,R30
	STS  _P+1,R31
	STS  _P+2,R22
	STS  _P+3,R23
	CALL SUBOPT_0x16
	CALL SUBOPT_0xA
	CALL SUBOPT_0x16
	CALL SUBOPT_0xB
	LDI  R30,LOW(_pre_to_http_buffer)
	LDI  R31,HIGH(_pre_to_http_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,15
_0x2080013:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_n1
	LDS  R31,_n1+1
	CALL __CWD1
	CALL __PUTPARD1
	LDS  R30,_n2
	LDS  R31,_n2+1
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
	RET
;//--------------------------------------
;#define ENC28J60_SPI_PORT       PORTB
;#define ENC28J60_SPI_DDR        DDRB
;#define ENC28J60_SPI_MISO       6
;#define ENC28J60_SPI_MOSI       5
;#define ENC28J60_SPI_SCK        7
;#define ENC28J60_SPI_CS         4
;// ethernet buffer size
;#define BUFFER_SIZE             1024
;#include "ethernet.h"
_enc28j60ReadOp:
	ST   -Y,R26
;	op -> Y+1
;	address -> Y+0
	CBI  0x18,4
	LD   R30,Y
	ANDI R30,LOW(0x1F)
	LDD  R26,Y+1
	OR   R30,R26
	OUT  0xF,R30
_0x8:
	SBIS 0xE,7
	RJMP _0x8
	LDI  R30,LOW(0)
	OUT  0xF,R30
_0xB:
	SBIS 0xE,7
	RJMP _0xB
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0xE
	LDI  R30,LOW(0)
	OUT  0xF,R30
_0xF:
	SBIS 0xE,7
	RJMP _0xF
_0xE:
	SBI  0x18,4
	IN   R30,0xF
	RJMP _0x2080011
_enc28j60WriteOp:
	ST   -Y,R26
;	op -> Y+2
;	address -> Y+1
;	data -> Y+0
	CBI  0x18,4
	LDD  R30,Y+1
	ANDI R30,LOW(0x1F)
	LDD  R26,Y+2
	OR   R30,R26
	OUT  0xF,R30
_0x12:
	SBIS 0xE,7
	RJMP _0x12
	LD   R30,Y
	OUT  0xF,R30
_0x15:
	SBIS 0xE,7
	RJMP _0x15
	SBI  0x18,4
	RJMP _0x208000F
_enc28j60ReadBuffer:
	ST   -Y,R27
	ST   -Y,R26
;	len -> Y+2
;	*data -> Y+0
	CBI  0x18,4
	LDI  R30,LOW(58)
	OUT  0xF,R30
_0x18:
	SBIS 0xE,7
	RJMP _0x18
_0x1B:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,0
	BREQ _0x1D
	SBIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	LDI  R30,LOW(0)
	OUT  0xF,R30
_0x1E:
	SBIS 0xE,7
	RJMP _0x1E
	IN   R30,0xF
	LD   R26,Y
	LDD  R27,Y+1
	ST   X,R30
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
	RJMP _0x1B
_0x1D:
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(0)
	ST   X,R30
	SBI  0x18,4
	RJMP _0x208000A
_enc28j60WriteBuffer:
	ST   -Y,R27
	ST   -Y,R26
;	len -> Y+2
;	*data -> Y+0
	CBI  0x18,4
	LDI  R30,LOW(122)
	OUT  0xF,R30
_0x21:
	SBIS 0xE,7
	RJMP _0x21
_0x24:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,0
	BREQ _0x26
	SBIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X
	OUT  0xF,R30
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
_0x27:
	SBIS 0xE,7
	RJMP _0x27
	RJMP _0x24
_0x26:
	SBI  0x18,4
	RJMP _0x208000A
_enc28j60SetBank:
	ST   -Y,R26
;	address -> Y+0
	LD   R30,Y
	ANDI R30,LOW(0x60)
	MOV  R26,R30
	LDS  R30,_Enc28j60Bank_G000
	CP   R30,R26
	BREQ _0x2A
	LDI  R30,LOW(160)
	ST   -Y,R30
	LDI  R30,LOW(31)
	ST   -Y,R30
	LDI  R26,LOW(3)
	CALL SUBOPT_0x17
	LDD  R30,Y+2
	ANDI R30,LOW(0x60)
	LDI  R31,0
	ASR  R31
	ROR  R30
	CALL __ASRW4
	MOV  R26,R30
	RCALL _enc28j60WriteOp
	LD   R30,Y
	ANDI R30,LOW(0x60)
	STS  _Enc28j60Bank_G000,R30
_0x2A:
	RJMP _0x2080012
_enc28j60Read:
	ST   -Y,R26
;	address -> Y+0
	LD   R26,Y
	RCALL _enc28j60SetBank
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDD  R26,Y+1
	RCALL _enc28j60ReadOp
_0x2080012:
	ADIW R28,1
	RET
;	address -> Y+0
_enc28j60Write:
	ST   -Y,R26
;	address -> Y+1
;	data -> Y+0
	LDD  R26,Y+1
	RCALL _enc28j60SetBank
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R26,Y+2
	RCALL _enc28j60WriteOp
	RJMP _0x2080011
_enc28j60PhyWrite:
	ST   -Y,R27
	ST   -Y,R26
;	address -> Y+2
;	data -> Y+0
	LDI  R30,LOW(212)
	ST   -Y,R30
	LDD  R26,Y+3
	RCALL _enc28j60Write
	LDI  R30,LOW(214)
	ST   -Y,R30
	LDD  R26,Y+1
	RCALL _enc28j60Write
	LDI  R30,LOW(215)
	ST   -Y,R30
	LDD  R26,Y+2
	RCALL _enc28j60Write
_0x2E:
	LDI  R26,LOW(234)
	RCALL _enc28j60Read
	ANDI R30,LOW(0x1)
	BREQ _0x30
	__DELAY_USB 40
	RJMP _0x2E
_0x30:
	RJMP _0x208000F
;	clk -> Y+0
_enc28j60Init:
	ST   -Y,R27
	ST   -Y,R26
;	*macaddr -> Y+0
	CBI  0x17,6
	IN   R30,0x17
	ORI  R30,LOW(0xB0)
	OUT  0x17,R30
	IN   R30,0x18
	ANDI R30,LOW(0x5F)
	OUT  0x18,R30
	SBI  0x18,4
	LDI  R30,LOW(80)
	OUT  0xD,R30
	SBI  0xE,0
	LDI  R30,LOW(255)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(255)
	RCALL _enc28j60WriteOp
	LDI  R26,LOW(50)
	CALL SUBOPT_0x2
	LDI  R30,LOW(0)
	STS  _NextPacketPtr_G000,R30
	STS  _NextPacketPtr_G000+1,R30
	LDI  R30,LOW(8)
	CALL SUBOPT_0x18
	LDI  R30,LOW(9)
	CALL SUBOPT_0x18
	LDI  R30,LOW(12)
	CALL SUBOPT_0x18
	LDI  R30,LOW(13)
	CALL SUBOPT_0x18
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R26,LOW(254)
	RCALL _enc28j60Write
	LDI  R30,LOW(11)
	CALL SUBOPT_0x19
	LDI  R30,LOW(4)
	CALL SUBOPT_0x1A
	LDI  R30,LOW(5)
	CALL SUBOPT_0x19
	LDI  R30,LOW(6)
	CALL SUBOPT_0x1A
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R26,LOW(31)
	RCALL _enc28j60Write
	LDI  R30,LOW(56)
	ST   -Y,R30
	LDI  R26,LOW(176)
	RCALL _enc28j60Write
	LDI  R30,LOW(40)
	ST   -Y,R30
	LDI  R26,LOW(63)
	RCALL _enc28j60Write
	LDI  R30,LOW(41)
	ST   -Y,R30
	LDI  R26,LOW(48)
	RCALL _enc28j60Write
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R26,LOW(249)
	RCALL _enc28j60Write
	LDI  R30,LOW(49)
	ST   -Y,R30
	LDI  R26,LOW(247)
	RCALL _enc28j60Write
	LDI  R30,LOW(192)
	ST   -Y,R30
	LDI  R26,LOW(13)
	RCALL _enc28j60Write
	LDI  R30,LOW(193)
	CALL SUBOPT_0x18
	LDI  R30,LOW(128)
	ST   -Y,R30
	LDI  R30,LOW(194)
	ST   -Y,R30
	LDI  R26,LOW(50)
	RCALL _enc28j60WriteOp
	LDI  R30,LOW(198)
	ST   -Y,R30
	LDI  R26,LOW(18)
	RCALL _enc28j60Write
	LDI  R30,LOW(199)
	ST   -Y,R30
	LDI  R26,LOW(12)
	RCALL _enc28j60Write
	LDI  R30,LOW(196)
	ST   -Y,R30
	LDI  R26,LOW(18)
	RCALL _enc28j60Write
	LDI  R30,LOW(202)
	ST   -Y,R30
	LDI  R26,LOW(220)
	RCALL _enc28j60Write
	LDI  R30,LOW(203)
	ST   -Y,R30
	LDI  R26,LOW(5)
	RCALL _enc28j60Write
	LDI  R30,LOW(228)
	ST   -Y,R30
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R26,X
	RCALL _enc28j60Write
	LDI  R30,LOW(229)
	ST   -Y,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Z+1
	RCALL _enc28j60Write
	LDI  R30,LOW(226)
	ST   -Y,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Z+2
	RCALL _enc28j60Write
	LDI  R30,LOW(227)
	ST   -Y,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Z+3
	RCALL _enc28j60Write
	LDI  R30,LOW(224)
	ST   -Y,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Z+4
	RCALL _enc28j60Write
	LDI  R30,LOW(225)
	ST   -Y,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Z+5
	RCALL _enc28j60Write
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R26,LOW(256)
	LDI  R27,HIGH(256)
	RCALL _enc28j60PhyWrite
	LDI  R26,LOW(31)
	RCALL _enc28j60SetBank
	LDI  R30,LOW(128)
	ST   -Y,R30
	LDI  R30,LOW(27)
	ST   -Y,R30
	LDI  R26,LOW(192)
	CALL SUBOPT_0x17
	LDI  R26,LOW(4)
	RCALL _enc28j60WriteOp
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R26,LOW(1142)
	LDI  R27,HIGH(1142)
	RCALL _enc28j60PhyWrite
	LDI  R26,LOW(20)
	CALL SUBOPT_0x2
_0x2080011:
	ADIW R28,2
	RET
_enc28j60PacketSend:
	ST   -Y,R27
	ST   -Y,R26
;	len -> Y+2
;	*packet -> Y+0
	LDI  R30,LOW(2)
	CALL SUBOPT_0x1A
	LDI  R30,LOW(3)
	CALL SUBOPT_0x19
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDD  R26,Y+3
	SUBI R26,-LOW(255)
	RCALL _enc28j60Write
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	SUBI R26,LOW(-6655)
	SBCI R27,HIGH(-6655)
	MOVW R30,R26
	MOV  R30,R31
	LDI  R31,0
	MOV  R26,R30
	RCALL _enc28j60Write
	LDI  R30,LOW(122)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _enc28j60WriteOp
	CALL SUBOPT_0x1B
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL _enc28j60WriteBuffer
	LDI  R30,LOW(128)
	CALL SUBOPT_0x1C
	LDI  R26,LOW(28)
	RCALL _enc28j60Read
	ANDI R30,LOW(0x2)
	BREQ _0x33
	LDI  R30,LOW(160)
	CALL SUBOPT_0x1C
_0x33:
	RJMP _0x208000A
_enc28j60PacketReceive:
	ST   -Y,R27
	ST   -Y,R26
	CALL __SAVELOCR4
;	maxlen -> Y+6
;	*packet -> Y+4
;	rxstat -> R16,R17
;	len -> R18,R19
	LDI  R26,LOW(57)
	RCALL _enc28j60Read
	CPI  R30,0
	BRNE _0x34
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __LOADLOCR4
	RJMP _0x2080010
_0x34:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R26,_NextPacketPtr_G000
	RCALL _enc28j60Write
	LDI  R30,LOW(1)
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
	LDI  R31,0
	CALL SUBOPT_0x1F
	MOV  R31,R30
	LDI  R30,0
	LDS  R26,_NextPacketPtr_G000
	LDS  R27,_NextPacketPtr_G000+1
	OR   R30,R26
	OR   R31,R27
	CALL SUBOPT_0x1F
	MOV  R18,R30
	CLR  R19
	CALL SUBOPT_0x1E
	MOV  R31,R30
	LDI  R30,0
	__ORWRR 18,19,30,31
	__SUBWRN 18,19,4
	CALL SUBOPT_0x1E
	MOV  R16,R30
	CLR  R17
	CALL SUBOPT_0x1E
	MOV  R31,R30
	LDI  R30,0
	__ORWRR 16,17,30,31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,1
	CP   R30,R18
	CPC  R31,R19
	BRSH _0x35
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,1
	MOVW R18,R30
_0x35:
	SBRC R16,7
	RJMP _0x36
	__GETWRN 18,19,0
	RJMP _0x37
_0x36:
	ST   -Y,R19
	ST   -Y,R18
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL _enc28j60ReadBuffer
_0x37:
	LDI  R30,LOW(12)
	ST   -Y,R30
	LDS  R26,_NextPacketPtr_G000
	RCALL _enc28j60Write
	LDI  R30,LOW(13)
	CALL SUBOPT_0x1D
	LDI  R30,LOW(128)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R26,LOW(64)
	RCALL _enc28j60WriteOp
	MOVW R30,R18
	CALL __LOADLOCR4
	RJMP _0x2080010

	.DSEG

	.CSEG
_checksum:
	ST   -Y,R26
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
;	*buf -> Y+7
;	len -> Y+5
;	type -> Y+4
;	sum -> Y+0
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BRNE _0x3B
	CALL SUBOPT_0x20
	__ADDD1N 17
	CALL SUBOPT_0x21
	CALL SUBOPT_0x22
_0x3B:
	LDD  R26,Y+4
	CPI  R26,LOW(0x2)
	BRNE _0x3C
	CALL SUBOPT_0x20
	__ADDD1N 6
	CALL SUBOPT_0x21
	CALL SUBOPT_0x22
_0x3C:
_0x3D:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,2
	BRLO _0x3F
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LD   R30,X
	LDI  R31,0
	CALL __CWD1
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(8)
	CALL __LSLD12
	MOVW R26,R30
	MOVW R24,R22
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	LDD  R30,Z+1
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ORD12
	__ANDD1N 0xFFFF
	CALL SUBOPT_0x23
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ADIW R30,2
	STD  Y+7,R30
	STD  Y+7+1,R31
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SBIW R30,2
	STD  Y+5,R30
	STD  Y+5+1,R31
	RJMP _0x3D
_0x3F:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SBIW R30,0
	BREQ _0x40
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(8)
	CALL __LSLD12
	CALL SUBOPT_0x23
_0x40:
_0x41:
	CALL SUBOPT_0x20
	CALL __LSRD16
	CALL __CPD10
	BREQ _0x43
	CALL SUBOPT_0x20
	__ANDD1N 0xFFFF
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x20
	CALL __LSRD16
	CALL __ADDD12
	CALL SUBOPT_0x21
	RJMP _0x41
_0x43:
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	EOR  R30,R26
	EOR  R31,R27
	RJMP _0x2080008
_eth_type_is_arp_and_my_ip:
	CALL SUBOPT_0x24
;	*buf -> Y+3
;	len -> Y+1
;	i -> R17
	SBIW R26,41
	BRSH _0x44
	LDI  R30,LOW(0)
	LDD  R17,Y+0
	JMP  _0x2080005
_0x44:
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADIW R26,12
	LD   R26,X
	CPI  R26,LOW(0x8)
	BRNE _0x46
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADIW R26,13
	LD   R26,X
	CPI  R26,LOW(0x6)
	BREQ _0x45
_0x46:
	LDI  R30,LOW(0)
	LDD  R17,Y+0
	JMP  _0x2080005
_0x45:
_0x48:
	CPI  R17,4
	BRSH _0x4A
	CALL SUBOPT_0x25
	ADIW R30,38
	CALL SUBOPT_0x26
	BREQ _0x4B
	LDI  R30,LOW(0)
	LDD  R17,Y+0
	JMP  _0x2080005
_0x4B:
	SUBI R17,-1
	RJMP _0x48
_0x4A:
	LDI  R30,LOW(1)
	LDD  R17,Y+0
	JMP  _0x2080005
_eth_type_is_ip_and_my_ip:
	CALL SUBOPT_0x24
;	*buf -> Y+3
;	len -> Y+1
;	i -> R17
	SBIW R26,42
	BRSH _0x4C
	LDI  R30,LOW(0)
	LDD  R17,Y+0
	JMP  _0x2080005
_0x4C:
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADIW R26,12
	LD   R26,X
	CPI  R26,LOW(0x8)
	BRNE _0x4E
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADIW R26,13
	LD   R26,X
	CPI  R26,LOW(0x0)
	BREQ _0x4D
_0x4E:
	LDI  R30,LOW(0)
	LDD  R17,Y+0
	JMP  _0x2080005
_0x4D:
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADIW R26,14
	LD   R26,X
	CPI  R26,LOW(0x45)
	BREQ _0x50
	LDI  R30,LOW(0)
	LDD  R17,Y+0
	JMP  _0x2080005
_0x50:
_0x51:
	CPI  R17,4
	BRSH _0x53
	CALL SUBOPT_0x25
	ADIW R30,30
	CALL SUBOPT_0x26
	BREQ _0x54
	LDI  R30,LOW(0)
	LDD  R17,Y+0
	JMP  _0x2080005
_0x54:
	SUBI R17,-1
	RJMP _0x51
_0x53:
	LDI  R30,LOW(1)
	LDD  R17,Y+0
	JMP  _0x2080005
_make_eth:
	CALL SUBOPT_0x27
;	*buf -> Y+1
;	i -> R17
_0x55:
	CPI  R17,6
	BRSH _0x57
	CALL SUBOPT_0x28
	ADIW R30,0
	CALL SUBOPT_0x29
	ADIW R30,6
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2B
	ADIW R30,6
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2C
	RJMP _0x55
_0x57:
	RJMP _0x208000E
_fill_ip_hdr_checksum:
	CALL SUBOPT_0x2D
;	*buf -> Y+2
;	ck -> R16,R17
	ADIW R26,24
	CALL SUBOPT_0x2E
	ADIW R26,25
	CALL SUBOPT_0x2E
	ADIW R26,20
	LDI  R30,LOW(64)
	ST   X,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,21
	CALL SUBOPT_0x2E
	ADIW R26,22
	LDI  R30,LOW(64)
	ST   X,R30
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,14
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL SUBOPT_0x2F
	__PUTB1SNS 2,24
	MOV  R30,R16
	__PUTB1SNS 2,25
	RJMP _0x208000B
_make_ip:
	CALL SUBOPT_0x27
;	*buf -> Y+1
;	i -> R17
_0x58:
	CPI  R17,4
	BRSH _0x5A
	CALL SUBOPT_0x28
	ADIW R30,30
	CALL SUBOPT_0x29
	ADIW R30,26
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2B
	ADIW R30,26
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x30
	RJMP _0x58
_0x5A:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RCALL _fill_ip_hdr_checksum
	RJMP _0x208000E
_make_tcphead:
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
;	*buf -> Y+6
;	rel_ack_num -> Y+4
;	mss -> Y+3
;	cp_seq -> Y+2
;	i -> R17
;	tseq -> R16
	LDI  R17,0
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R30,Z+34
	__PUTB1SNS 6,36
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R30,Z+35
	__PUTB1SNS 6,37
	LDS  R30,_wwwport_G000
	__PUTB1SNS 6,35
	LDS  R30,_wwwport_G000+1
	__PUTB1SNS 6,34
	LDI  R17,LOW(4)
_0x5B:
	CPI  R17,1
	BRLO _0x5D
	CALL SUBOPT_0x31
	CALL SUBOPT_0x32
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	LDI  R31,0
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+4,R30
	STD  Y+4+1,R31
	CALL SUBOPT_0x31
	CALL SUBOPT_0x33
	LD   R16,X
	CALL SUBOPT_0x31
	CALL SUBOPT_0x33
	LDD  R30,Y+4
	ST   X,R30
	LDD  R30,Y+2
	CPI  R30,0
	BREQ _0x5E
	CALL SUBOPT_0x31
	CALL SUBOPT_0x32
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R16
	RJMP _0x5F
_0x5E:
	CALL SUBOPT_0x31
	CALL SUBOPT_0x32
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
_0x5F:
	LDD  R30,Y+5
	ANDI R31,HIGH(0x0)
	STD  Y+4,R30
	STD  Y+4+1,R31
	SUBI R17,1
	RJMP _0x5B
_0x5D:
	LDD  R30,Y+2
	CPI  R30,0
	BRNE _0x60
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,38
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,39
	ST   X,R30
	LDS  R30,_seqnum_G000
	__PUTB1SNS 6,40
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,41
	LDI  R30,LOW(0)
	ST   X,R30
	LDS  R30,_seqnum_G000
	SUBI R30,-LOW(2)
	STS  _seqnum_G000,R30
_0x60:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,50
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,51
	ST   X,R30
	LDD  R30,Y+3
	CPI  R30,0
	BREQ _0x61
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,54
	LDI  R30,LOW(2)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,55
	LDI  R30,LOW(4)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,56
	LDI  R30,LOW(5)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,57
	LDI  R30,LOW(128)
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,46
	LDI  R30,LOW(96)
	RJMP _0x99
_0x61:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,46
	LDI  R30,LOW(80)
_0x99:
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x2080010:
	ADIW R28,8
	RET
_make_arp_answer_from_request:
	CALL SUBOPT_0x24
;	*buf -> Y+1
;	i -> R17
	RCALL _make_eth
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,20
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,21
	LDI  R30,LOW(2)
	ST   X,R30
_0x63:
	CPI  R17,6
	BRSH _0x65
	CALL SUBOPT_0x28
	ADIW R30,32
	CALL SUBOPT_0x29
	ADIW R30,22
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2B
	ADIW R30,22
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2C
	RJMP _0x63
_0x65:
	LDI  R17,LOW(0)
_0x66:
	CPI  R17,4
	BRSH _0x68
	CALL SUBOPT_0x28
	ADIW R30,38
	CALL SUBOPT_0x29
	ADIW R30,28
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2B
	ADIW R30,28
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x30
	RJMP _0x66
_0x68:
	LDI  R30,LOW(42)
	LDI  R31,HIGH(42)
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL _enc28j60PacketSend
_0x208000E:
	LDD  R17,Y+0
_0x208000F:
	ADIW R28,3
	RET
_make_echo_reply_from_request:
	ST   -Y,R27
	ST   -Y,R26
;	*buf -> Y+2
;	len -> Y+0
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL SUBOPT_0x34
	RCALL _make_ip
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,34
	CALL SUBOPT_0x2E
	ADIW R26,36
	LD   R26,X
	CPI  R26,LOW(0xF8)
	BRLO _0x69
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,37
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
_0x69:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,36
	LD   R30,X
	SUBI R30,-LOW(8)
	ST   X,R30
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL _enc28j60PacketSend
	RJMP _0x208000A
_make_udp_reply_from_request:
	ST   -Y,R26
	CALL __SAVELOCR4
;	*buf -> Y+5
;	datalen -> Y+4
;	i -> R17
;	ck -> R18,R19
	LDI  R17,0
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	RCALL _make_eth
	LDD  R26,Y+4
	CPI  R26,LOW(0xDD)
	BRLO _0x6A
	LDI  R30,LOW(220)
	STD  Y+4,R30
_0x6A:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADIW R26,16
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R30,Y+4
	SUBI R30,-LOW(28)
	__PUTB1SNS 5,17
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	RCALL _make_ip
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LDD  R30,Z+34
	__PUTB1SNS 5,36
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LDD  R30,Z+35
	__PUTB1SNS 5,37
	LDS  R30,_udpport_G000+1
	__PUTB1SNS 5,34
	LDS  R30,_udpport_G000
	__PUTB1SNS 5,35
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADIW R26,38
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R30,Y+4
	SUBI R30,-LOW(8)
	__PUTB1SNS 5,39
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADIW R26,40
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADIW R26,41
	ST   X,R30
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+6
	LDI  R31,0
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(1)
	RCALL _checksum
	MOVW R18,R30
	MOV  R30,R19
	__PUTB1SNS 5,40
	MOV  R30,R18
	__PUTB1SNS 5,41
	LDD  R30,Y+4
	LDI  R31,0
	ADIW R30,42
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	RCALL _enc28j60PacketSend
	CALL __LOADLOCR4
	RJMP _0x208000D
_make_tcp_synack_from_syn:
	CALL SUBOPT_0x2D
;	*buf -> Y+2
;	ck -> R16,R17
	CALL SUBOPT_0x34
	ADIW R26,16
	CALL SUBOPT_0x2E
	ADIW R26,17
	LDI  R30,LOW(44)
	ST   X,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL _make_ip
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,47
	LDI  R30,LOW(18)
	ST   X,R30
	CALL SUBOPT_0x1B
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _make_tcphead
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	CALL SUBOPT_0x35
	CALL SUBOPT_0x36
	LDI  R30,LOW(58)
	LDI  R31,HIGH(58)
	RJMP _0x2080009
_get_tcp_data_pointer:
	ST   -Y,R27
	ST   -Y,R26
;	*buf -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R30,Z+16
	MOV  R31,R30
	LDI  R30,0
	MOVW R26,R30
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R30,Z+17
	LDI  R31,0
	ANDI R31,HIGH(0xFF)
	OR   R30,R26
	OR   R31,R27
	CALL SUBOPT_0x37
	CALL SUBOPT_0x38
	SBIW R30,20
	CALL SUBOPT_0x37
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R30,Z+46
	CALL SUBOPT_0x39
	CALL __LSLW2
	STS  _info_hdr_len_G000,R30
	STS  _info_hdr_len_G000+1,R31
	LDS  R26,_info_hdr_len_G000
	LDS  R27,_info_hdr_len_G000+1
	CALL SUBOPT_0x38
	SUB  R30,R26
	SBC  R31,R27
	CALL SUBOPT_0x37
	LDS  R26,_info_data_len_G000
	LDS  R27,_info_data_len_G000+1
	CALL __CPW02
	BRLT _0x6B
	LDI  R30,LOW(0)
	STS  _info_data_len_G000,R30
	STS  _info_data_len_G000+1,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	JMP  _0x2080003
_0x6B:
	LDS  R30,_info_hdr_len_G000
	LDS  R31,_info_hdr_len_G000+1
	ADIW R30,34
	JMP  _0x2080003
_concatstrf:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
;	*buf -> Y+5
;	pos -> Y+3
;	*s -> Y+1
;	c -> R17
_0x6C:
	CALL SUBOPT_0x3A
	BREQ _0x6E
	CALL SUBOPT_0x3B
	RJMP _0x6C
_0x6E:
	RJMP _0x208000C
_concatstr:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
;	*buf -> Y+5
;	pos -> Y+3
;	*s -> Y+1
;	c -> R17
_0x6F:
	CALL SUBOPT_0x3C
	BREQ _0x71
	CALL SUBOPT_0x3B
	RJMP _0x6F
_0x71:
_0x208000C:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	LDD  R17,Y+0
_0x208000D:
	ADIW R28,7
	RET
_make_tcp_ack_from_any:
	CALL SUBOPT_0x2D
;	*buf -> Y+2
;	j -> R16,R17
	CALL SUBOPT_0x34
	ADIW R26,47
	LDI  R30,LOW(16)
	ST   X,R30
	CALL SUBOPT_0x38
	SBIW R30,0
	BRNE _0x72
	CALL SUBOPT_0x1B
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x9A
_0x72:
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x38
_0x9A:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	RCALL _make_tcphead
	__GETWRN 16,17,40
	MOV  R30,R17
	__PUTB1SNS 2,16
	MOV  R30,R16
	__PUTB1SNS 2,17
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL _make_ip
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CALL SUBOPT_0x35
	CALL SUBOPT_0x36
	LDI  R30,LOW(54)
	LDI  R31,HIGH(54)
_0x2080009:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL _enc28j60PacketSend
_0x208000B:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x208000A:
	ADIW R28,4
	RET
_make_tcp_ack_with_data:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
;	*buf -> Y+4
;	dlen -> Y+2
;	j -> R16,R17
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,47
	LDI  R30,LOW(25)
	ST   X,R30
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,40
	MOVW R16,R30
	MOV  R30,R17
	__PUTB1SNS 4,16
	MOV  R30,R16
	__PUTB1SNS 4,17
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL _fill_ip_hdr_checksum
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,50
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,51
	ST   X,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,28
	CALL SUBOPT_0x35
	__PUTB1SNS 4,50
	MOV  R30,R16
	__PUTB1SNS 4,51
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,54
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL _enc28j60PacketSend
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x2080007
_ethernet_init:
	CALL SUBOPT_0x27
;	*dev_mac -> Y+7
;	*dev_ip -> Y+5
;	port_tcp -> Y+3
;	port_udp -> Y+1
;	i -> R17
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	STS  _wwwport_G000,R30
	STS  _wwwport_G000+1,R31
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	STS  _udpport_G000,R30
	STS  _udpport_G000+1,R31
_0x74:
	CPI  R17,4
	BRSH _0x76
	CALL SUBOPT_0x31
	SUBI R30,LOW(-_ipaddr_G000)
	SBCI R31,HIGH(-_ipaddr_G000)
	MOVW R0,R30
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	CALL SUBOPT_0x3D
	RJMP _0x74
_0x76:
	LDI  R17,LOW(0)
_0x77:
	CPI  R17,6
	BRSH _0x79
	CALL SUBOPT_0x31
	SUBI R30,LOW(-_macaddr_G000)
	SBCI R31,HIGH(-_macaddr_G000)
	MOVW R0,R30
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CALL SUBOPT_0x3D
	RJMP _0x77
_0x79:
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	RCALL _enc28j60Init
	LDD  R17,Y+0
_0x2080008:
	ADIW R28,9
	RET
_ethernet_process:
	CALL __SAVELOCR6
;	plen -> R16,R17
;	data_p -> R18,R19
;	data_len -> R21
	LDI  R30,LOW(1024)
	LDI  R31,HIGH(1024)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _enc28j60PacketReceive
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BRNE PC+3
	JMP _0x7A
	CALL SUBOPT_0x3E
	RCALL _eth_type_is_arp_and_my_ip
	CPI  R30,0
	BREQ _0x7B
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _make_arp_answer_from_request
	RJMP _0x7C
_0x7B:
	CALL SUBOPT_0x3E
	RCALL _eth_type_is_ip_and_my_ip
	CPI  R30,0
	BRNE PC+3
	JMP _0x7D
	__GETB2MN _eth_buf,23
	CPI  R26,LOW(0x1)
	BRNE _0x7F
	__GETB2MN _eth_buf,34
	CPI  R26,LOW(0x8)
	BREQ _0x80
_0x7F:
	RJMP _0x7E
_0x80:
	CALL SUBOPT_0x3E
	RCALL _make_echo_reply_from_request
	RJMP _0x81
_0x7E:
	__GETB2MN _eth_buf,23
	CPI  R26,LOW(0x6)
	BRNE _0x83
	__GETB2MN _eth_buf,36
	LDS  R30,_wwwport_G000+1
	CALL SUBOPT_0x3F
	BRNE _0x83
	__GETB2MN _eth_buf,37
	LDS  R30,_wwwport_G000
	LDS  R31,_wwwport_G000+1
	CALL SUBOPT_0x40
	BREQ _0x84
_0x83:
	RJMP _0x82
_0x84:
	__GETB1MN _eth_buf,47
	ANDI R30,LOW(0x2)
	BREQ _0x85
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _make_tcp_synack_from_syn
	RJMP _0x86
_0x85:
	__GETB1MN _eth_buf,47
	ANDI R30,LOW(0x10)
	BREQ _0x87
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _get_tcp_data_pointer
	MOVW R18,R30
	MOV  R0,R18
	OR   R0,R19
	BRNE _0x88
	__GETB1MN _eth_buf,47
	ANDI R30,LOW(0x1)
	BREQ _0x89
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _make_tcp_ack_from_any
_0x89:
	RJMP _0x8A
_0x88:
	MOVW R30,R18
	SUBI R30,LOW(-_eth_buf)
	SBCI R31,HIGH(-_eth_buf)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW2MN _eth_buf,54
	RCALL _ethernet_tcp
	MOVW R16,R30
	LDI  R26,LOW(_eth_buf)
	LDI  R27,HIGH(_eth_buf)
	RCALL _make_tcp_ack_from_any
	CALL SUBOPT_0x3E
	RCALL _make_tcp_ack_with_data
_0x8A:
_0x87:
_0x86:
	RJMP _0x8B
_0x82:
	__GETB2MN _eth_buf,23
	CPI  R26,LOW(0x11)
	BRNE _0x8D
	__GETB2MN _eth_buf,36
	LDS  R30,_udpport_G000+1
	CALL SUBOPT_0x3F
	BRNE _0x8D
	__GETB2MN _eth_buf,37
	LDS  R30,_udpport_G000
	LDS  R31,_udpport_G000+1
	CALL SUBOPT_0x40
	BREQ _0x8E
_0x8D:
	RJMP _0x8C
_0x8E:
	__GETB1MN _eth_buf,39
	SUBI R30,LOW(8)
	MOV  R21,R30
	__POINTW1MN _eth_buf,42
	ST   -Y,R31
	ST   -Y,R30
	MOV  R26,R21
	RCALL _ethernet_udp
	MOV  R21,R30
	LDI  R30,LOW(_eth_buf)
	LDI  R31,HIGH(_eth_buf)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R26,R21
	RCALL _make_udp_reply_from_request
_0x8C:
_0x8B:
_0x81:
_0x7D:
_0x7C:
_0x7A:
	CALL __LOADLOCR6
_0x2080007:
	ADIW R28,6
	RET
;//--------------------------------------
;
;
;#define DIPSWITCH               (PIND>>4)
;
;//--------------------------------------
;unsigned char   mymac[6] = {0x11,0x22,0x33,0x44,0x55,0x66};     // MAC

	.DSEG
;unsigned char   myip[4] = {192,168,1,10};                       // IP
;unsigned char   time_cs = 0;            // 1/100 second counter
;unsigned int    time_s = 0;             // seconds counter
;unsigned int    counter1 = 0;           // button 1 clicks
;unsigned int    counter2 = 0;           // button 2 clicks
;//--------------------------------------
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)  // Timer 1 overflow ISR
; 0000 002A {

	.CSEG
_timer1_ovf_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 002B 
; 0000 002C         static bit old_btn1 = 0, old_btn2 = 0;
; 0000 002D         if (++time_cs==100)             // one second elapsed
	LDS  R26,_time_cs
	SUBI R26,-LOW(1)
	STS  _time_cs,R26
	CPI  R26,LOW(0x64)
	BRNE _0x91
; 0000 002E         {
; 0000 002F                 time_cs = 0;
	LDI  R30,LOW(0)
	STS  _time_cs,R30
; 0000 0030                 time_s ++;
	LDI  R26,LOW(_time_s)
	LDI  R27,HIGH(_time_s)
	CALL SUBOPT_0x41
; 0000 0031                 #asm("wdr");
	wdr
; 0000 0032         }
; 0000 0033 
; 0000 0034 }
_0x91:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;//--------------------------------------
;void main(void)
; 0000 0037 {
_main:
; 0000 0038         uint8_t str[20]="";     // buffer to
; 0000 0039         char t_lcd_buffer_1[10],t_lcd_buffer_2[10];
; 0000 003A    // Watchdog Timer Enabled with Prescaler: OSC/512k
; 0000 003B       WDTCR=0x0D;
	SBIW R28,40
	LDI  R24,20
	LDI  R26,LOW(20)
	LDI  R27,HIGH(20)
	LDI  R30,LOW(_0x92*2)
	LDI  R31,HIGH(_0x92*2)
	CALL __INITLOCB
;	str -> Y+20
;	t_lcd_buffer_1 -> Y+10
;	t_lcd_buffer_2 -> Y+0
	LDI  R30,LOW(13)
	OUT  0x21,R30
; 0000 003C 
; 0000 003D         PORTB=0x03;
	LDI  R30,LOW(3)
	OUT  0x18,R30
; 0000 003E         DDRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x17,R30
; 0000 003F 
; 0000 0040 
; 0000 0041         PORTD=0xF0;
	LDI  R30,LOW(240)
	OUT  0x12,R30
; 0000 0042         DDRD=0x00;
	LDI  R30,LOW(0)
	OUT  0x11,R30
; 0000 0043 
; 0000 0044         // Timer 1 interrupts every 10 ms
; 0000 0045         TCCR1A=0x02;
	LDI  R30,LOW(2)
	OUT  0x2F,R30
; 0000 0046         TCCR1B=0x19;
	LDI  R30,LOW(25)
	OUT  0x2E,R30
; 0000 0047         ICR1H=0xF4;
	LDI  R30,LOW(244)
	OUT  0x27,R30
; 0000 0048         ICR1L=0x23;
	LDI  R30,LOW(35)
	OUT  0x26,R30
; 0000 0049         // Timer(s) Interrupt(s) initialization
; 0000 004A         TIMSK=0x04;
	LDI  R30,LOW(4)
	OUT  0x39,R30
; 0000 004B         // Analog Comparator: Off
; 0000 004C         ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 004D 
; 0000 004E 
; 0000 004F 
; 0000 0050         // LCD module initialization
; 0000 0051         lcd_init(16);
	LDI  R26,LOW(16)
	CALL _lcd_init
; 0000 0052         /// milad added
; 0000 0053         lcd_clear();
	CALL _lcd_clear
; 0000 0054         lcd_putsf("Sajad Shamsi");
	__POINTW2FN _0x0,31
	CALL _lcd_putsf
; 0000 0055         delay_ms(2000);
	LDI  R26,LOW(2000)
	LDI  R27,HIGH(2000)
	CALL _delay_ms
; 0000 0056         #asm("wdr");
	wdr
; 0000 0057         // setting MAC & IP using dip-switch state
; 0000 0058         mymac[0] += DIPSWITCH;
	IN   R30,0x10
	CALL SUBOPT_0x39
	LDS  R26,_mymac
	ADD  R30,R26
	STS  _mymac,R30
; 0000 0059         myip[3] += DIPSWITCH;
	__POINTW1MN _myip,3
	MOVW R0,R30
	LD   R26,Z
	IN   R30,0x10
	CALL SUBOPT_0x39
	ADD  R30,R26
	MOVW R26,R0
	ST   X,R30
; 0000 005A         // initialize ethernet
; 0000 005B         ethernet_init(mymac, myip, 80, 1200);
	LDI  R30,LOW(_mymac)
	LDI  R31,HIGH(_mymac)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_myip)
	LDI  R31,HIGH(_myip)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(1200)
	LDI  R27,HIGH(1200)
	RCALL _ethernet_init
; 0000 005C         // start up display
; 0000 005D         lcd_gotoxy(0,0);
	CALL SUBOPT_0x42
; 0000 005E         lcd_putsf("      MAC       ");
	__POINTW2FN _0x0,44
	CALL SUBOPT_0x43
; 0000 005F         lcd_gotoxy(0,1);
; 0000 0060         sprintf(str, " %02x%02x-%02x%02x-%02x%02x ",
; 0000 0061                 mymac[0], mymac[1], mymac[2], mymac[3], mymac[4], mymac[5]);
	__POINTW1FN _0x0,61
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_mymac
	CALL SUBOPT_0x44
	__GETB1MN _mymac,1
	CALL SUBOPT_0x44
	__GETB1MN _mymac,2
	CALL SUBOPT_0x44
	__GETB1MN _mymac,3
	CALL SUBOPT_0x44
	__GETB1MN _mymac,4
	CALL SUBOPT_0x44
	__GETB1MN _mymac,5
	CALL SUBOPT_0x44
	LDI  R24,24
	CALL _sprintf
	ADIW R28,28
; 0000 0062         lcd_puts(str);
	MOVW R26,R28
	ADIW R26,20
	CALL _lcd_puts
; 0000 0063         delay_ms(2000);
	LDI  R26,LOW(2000)
	LDI  R27,HIGH(2000)
	CALL _delay_ms
; 0000 0064         lcd_gotoxy(0,0);
	CALL SUBOPT_0x42
; 0000 0065         lcd_putsf("       IP       ");
	__POINTW2FN _0x0,90
	CALL SUBOPT_0x43
; 0000 0066         lcd_gotoxy(0,1);
; 0000 0067         sprintf(str, "%03u.%03u.%03u.%03u",
; 0000 0068                 myip[0], myip[1], myip[2], myip[3]);
	__POINTW1FN _0x0,107
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_myip
	CALL SUBOPT_0x44
	__GETB1MN _myip,1
	CALL SUBOPT_0x44
	__GETB1MN _myip,2
	CALL SUBOPT_0x44
	__GETB1MN _myip,3
	CALL SUBOPT_0x44
	LDI  R24,16
	CALL _sprintf
	ADIW R28,20
; 0000 0069         lcd_puts(str);
	MOVW R26,R28
	ADIW R26,20
	CALL _lcd_puts
; 0000 006A         delay_ms(3000);
	LDI  R26,LOW(3000)
	LDI  R27,HIGH(3000)
	CALL _delay_ms
; 0000 006B         lcd_clear();
	CALL _lcd_clear
; 0000 006C 
; 0000 006D           i2c_init();
	CALL _i2c_init
; 0000 006E         calibre();
	CALL _calibre
; 0000 006F 
; 0000 0070 
; 0000 0071         // Global enable interrupts
; 0000 0072         #asm("sei")
	sei
; 0000 0073         #asm("wdr");
	wdr
; 0000 0074 
; 0000 0075 
; 0000 0076         while (1)
_0x93:
; 0000 0077         {
; 0000 0078                 #asm("wdr");
	wdr
; 0000 0079 
; 0000 007A                 lcd_gotoxy(0,0);
	CALL SUBOPT_0x42
; 0000 007B 
; 0000 007C                 lcd_puts(temp_to_http_buffer);
	LDI  R26,LOW(_temp_to_http_buffer)
	LDI  R27,HIGH(_temp_to_http_buffer)
	CALL _lcd_puts
; 0000 007D                 delay_ms(1);
	LDI  R26,LOW(1)
	CALL SUBOPT_0x2
; 0000 007E                 lcd_gotoxy(0,1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
; 0000 007F                 lcd_puts(pre_to_http_buffer);
	LDI  R26,LOW(_pre_to_http_buffer)
	LDI  R27,HIGH(_pre_to_http_buffer)
	CALL _lcd_puts
; 0000 0080 
; 0000 0081                show_temp();
	CALL _show_temp
; 0000 0082                show_pre();
	CALL _show_pre
; 0000 0083                ethernet_process(); //process ethernet transactions
	RCALL _ethernet_process
; 0000 0084                delay_ms(200);
	LDI  R26,LOW(200)
	CALL SUBOPT_0x2
; 0000 0085         }
	RJMP _0x93
; 0000 0086 }
_0x96:
	RJMP _0x96
;//--------------------------------------
;unsigned char ethernet_udp(unsigned char* data, unsigned char data_len)
; 0000 0089 {
_ethernet_udp:
; 0000 008A         unsigned char str[20];
; 0000 008B        // lcd_gotoxy(0,1);
; 0000 008C        // lcd_putsf("UDP:            ");
; 0000 008D         strncpy(str, data, 11);
	ST   -Y,R26
	SBIW R28,20
;	*data -> Y+21
;	data_len -> Y+20
;	str -> Y+0
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(11)
	CALL _strncpy
; 0000 008E        // lcd_gotoxy(4,1);
; 0000 008F        // lcd_puts(str);
; 0000 0090         // response the request
; 0000 0091         sprintf(str, "T=%u,P=%u,%u\n", time_s, counter1, counter2 );
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,127
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_time_s
	LDS  R31,_time_s+1
	CALL SUBOPT_0x45
	LDS  R30,_counter1
	LDS  R31,_counter1+1
	CALL SUBOPT_0x45
	LDS  R30,_counter2
	LDS  R31,_counter2+1
	CALL SUBOPT_0x45
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
; 0000 0092         data_len = concatstr(data, 0, str);
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	CALL SUBOPT_0x46
	MOVW R26,R28
	ADIW R26,4
	RCALL _concatstr
	STD  Y+20,R30
; 0000 0093         time_cs = 0;
	CALL SUBOPT_0x47
; 0000 0094         time_s = 0;
; 0000 0095         return data_len;
	LDD  R30,Y+20
	ADIW R28,23
	RET
; 0000 0096 }
;//--------------------------------------
;unsigned int ethernet_tcp(unsigned char* request, unsigned char* response)
; 0000 0099 {
_ethernet_tcp:
; 0000 009A         unsigned int len;
; 0000 009B         unsigned char str[20];
; 0000 009C         if (strncmpf(request, "GET /", 5)!=0)
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,20
	ST   -Y,R17
	ST   -Y,R16
;	*request -> Y+24
;	*response -> Y+22
;	len -> R16,R17
;	str -> Y+2
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,141
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(5)
	CALL _strncmpf
	CPI  R30,0
	BREQ _0x97
; 0000 009D                 return 0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP _0x2080006
; 0000 009E      //   lcd_gotoxy(0,1);
; 0000 009F     //    lcd_putsf("TCP:            ");
; 0000 00A0     //    strncpy(str, request+5, 11);
; 0000 00A1      //   lcd_gotoxy(4,1);
; 0000 00A2       //  lcd_puts(str);
; 0000 00A3         // response the request
; 0000 00A4         len = concatstrf(response, 0, "HTTP/1.0 200 OK\r\n");
_0x97:
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	CALL SUBOPT_0x46
	__POINTW2FN _0x0,147
	CALL SUBOPT_0x48
; 0000 00A5         len = concatstrf(response, len, "Content-Type: text/html\r\n");
	__POINTW2FN _0x0,165
	CALL SUBOPT_0x48
; 0000 00A6         len = concatstrf(response, len, "Pragma: no-cache\r\n\r\n");
	__POINTW2FN _0x0,191
	CALL SUBOPT_0x48
; 0000 00A7         len = concatstrf(response, len,
; 0000 00A8                 "<HTML><TITLE> DAMA AND FESHAR  </TITLE><BODY><CENTER>");
	__POINTW2FN _0x0,212
	CALL SUBOPT_0x48
; 0000 00A9         len = concatstrf(response, len,
; 0000 00AA                 "<P> Sajad Shamsi  </P>\n<HR>");
	__POINTW2FN _0x0,266
	CALL SUBOPT_0x48
; 0000 00AB        // len = concatstrf(response, len,
; 0000 00AC        //         "<P>Time = <FONT COLOR=#00FF00> ");
; 0000 00AD        // sprintf(str, "%u", time_s);
; 0000 00AE        // len = concatstr(response, len, str);
; 0000 00AF        // len = concatstrf(response, len, "</FONT></P>\n");
; 0000 00B0         len = concatstrf(response, len,
; 0000 00B1                 "<P> <FONT COLOR=#0000FF> ");
	__POINTW2FN _0x0,294
	CALL SUBOPT_0x48
; 0000 00B2        // sprintf(str, "%u C", 29 );
; 0000 00B3         //len = concatstr(response, len, str);
; 0000 00B4 
; 0000 00B5         len = concatstr(response, len, temp_to_http_buffer);
	LDI  R26,LOW(_temp_to_http_buffer)
	LDI  R27,HIGH(_temp_to_http_buffer)
	CALL SUBOPT_0x49
; 0000 00B6         len = concatstr(response, len, pre_to_http_buffer);
	LDI  R26,LOW(_pre_to_http_buffer)
	LDI  R27,HIGH(_pre_to_http_buffer)
	CALL SUBOPT_0x49
; 0000 00B7 
; 0000 00B8         len = concatstrf(response, len, "</FONT></P>\n");
	__POINTW2FN _0x0,320
	CALL SUBOPT_0x48
; 0000 00B9        // len = concatstrf(response, len,
; 0000 00BA        //         "<P>Counter_2 = <FONT COLOR=#FF0000> ");
; 0000 00BB        // sprintf(str, "%u", counter2);
; 0000 00BC        // len = concatstr(response, len, str);
; 0000 00BD         len = concatstrf(response, len, "</FONT></P>\n");
	__POINTW2FN _0x0,320
	CALL SUBOPT_0x48
; 0000 00BE         len = concatstrf(response, len,
; 0000 00BF                 "<P><A HREF=\".\">refresh</A><P></CENTER><HR>\n");
	__POINTW2FN _0x0,333
	RCALL _concatstrf
	MOVW R16,R30
; 0000 00C0         time_cs = 0;
	CALL SUBOPT_0x47
; 0000 00C1         time_s = 0;
; 0000 00C2         return len;
	MOVW R30,R16
_0x2080006:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,26
	RET
; 0000 00C3 }
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G100:
	CALL SUBOPT_0x2D
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL SUBOPT_0x41
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2000014
	CALL SUBOPT_0x41
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x2080005:
	ADIW R28,5
	RET
__print_G100:
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,11
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+17
	LDD  R27,Y+17+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ADIW R30,1
	STD  Y+23,R30
	STD  Y+23+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	CALL SUBOPT_0x4A
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	CALL SUBOPT_0x4A
	RJMP _0x20000CF
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BRNE _0x2000028
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	CPI  R18,108
	BRNE _0x200002C
	ORI  R16,LOW(2)
	LDI  R17,LOW(5)
	RJMP _0x200001B
_0x200002C:
	RJMP _0x200002D
_0x2000028:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x200001B
_0x200002D:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x2000032
	CALL SUBOPT_0x4B
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x4C
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x73)
	BRNE _0x2000035
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x4D
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x70)
	BRNE _0x2000038
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x4D
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000036:
	ANDI R16,LOW(127)
	LDI  R30,LOW(0)
	STD  Y+16,R30
	LDI  R19,LOW(0)
	RJMP _0x2000039
_0x2000038:
	CPI  R30,LOW(0x64)
	BREQ _0x200003C
	CPI  R30,LOW(0x69)
	BRNE _0x200003D
_0x200003C:
	ORI  R16,LOW(4)
	RJMP _0x200003E
_0x200003D:
	CPI  R30,LOW(0x75)
	BRNE _0x200003F
_0x200003E:
	LDI  R30,LOW(10)
	STD  Y+16,R30
	SBRS R16,1
	RJMP _0x2000040
	__GETD1N 0x3B9ACA00
	CALL SUBOPT_0x4E
	LDI  R17,LOW(10)
	RJMP _0x2000041
_0x2000040:
	__GETD1N 0x2710
	CALL SUBOPT_0x4E
	LDI  R17,LOW(5)
	RJMP _0x2000041
_0x200003F:
	CPI  R30,LOW(0x58)
	BRNE _0x2000043
	ORI  R16,LOW(8)
	RJMP _0x2000044
_0x2000043:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2000077
_0x2000044:
	LDI  R30,LOW(16)
	STD  Y+16,R30
	SBRS R16,1
	RJMP _0x2000046
	__GETD1N 0x10000000
	CALL SUBOPT_0x4E
	LDI  R17,LOW(8)
	RJMP _0x2000041
_0x2000046:
	__GETD1N 0x1000
	CALL SUBOPT_0x4E
	LDI  R17,LOW(4)
_0x2000041:
	SBRS R16,1
	RJMP _0x2000047
	CALL SUBOPT_0x4B
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETD1P
	RJMP _0x20000D0
_0x2000047:
	SBRS R16,2
	RJMP _0x2000049
	CALL SUBOPT_0x4B
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETW1P
	CALL __CWD1
	RJMP _0x20000D0
_0x2000049:
	CALL SUBOPT_0x4B
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETW1P
	CLR  R22
	CLR  R23
_0x20000D0:
	__PUTD1S 12
	SBRS R16,2
	RJMP _0x200004B
	LDD  R26,Y+15
	TST  R26
	BRPL _0x200004C
	__GETD1S 12
	CALL __ANEGD1
	__PUTD1S 12
	LDI  R20,LOW(45)
_0x200004C:
	CPI  R20,0
	BREQ _0x200004D
	SUBI R17,-LOW(1)
	RJMP _0x200004E
_0x200004D:
	ANDI R16,LOW(251)
_0x200004E:
_0x200004B:
_0x2000039:
	SBRC R16,0
	RJMP _0x200004F
_0x2000050:
	CP   R17,R21
	BRSH _0x2000052
	SBRS R16,7
	RJMP _0x2000053
	SBRS R16,2
	RJMP _0x2000054
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x2000055
_0x2000054:
	LDI  R18,LOW(48)
_0x2000055:
	RJMP _0x2000056
_0x2000053:
	LDI  R18,LOW(32)
_0x2000056:
	CALL SUBOPT_0x4A
	SUBI R21,LOW(1)
	RJMP _0x2000050
_0x2000052:
_0x200004F:
	MOV  R19,R17
	LDD  R30,Y+16
	CPI  R30,0
	BRNE _0x2000057
_0x2000058:
	CPI  R19,0
	BREQ _0x200005A
	SBRS R16,3
	RJMP _0x200005B
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x200005C
_0x200005B:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x200005C:
	CALL SUBOPT_0x4A
	CPI  R21,0
	BREQ _0x200005D
	SUBI R21,LOW(1)
_0x200005D:
	SUBI R19,LOW(1)
	RJMP _0x2000058
_0x200005A:
	RJMP _0x200005E
_0x2000057:
_0x2000060:
	CALL SUBOPT_0x4F
	CALL __DIVD21U
	MOV  R18,R30
	CPI  R18,10
	BRLO _0x2000062
	SBRS R16,3
	RJMP _0x2000063
	SUBI R18,-LOW(55)
	RJMP _0x2000064
_0x2000063:
	SUBI R18,-LOW(87)
_0x2000064:
	RJMP _0x2000065
_0x2000062:
	SUBI R18,-LOW(48)
_0x2000065:
	SBRC R16,4
	RJMP _0x2000067
	CPI  R18,49
	BRSH _0x2000069
	__GETD2S 8
	__CPD2N 0x1
	BRNE _0x2000068
_0x2000069:
	RJMP _0x200006B
_0x2000068:
	CP   R21,R19
	BRLO _0x200006D
	SBRS R16,0
	RJMP _0x200006E
_0x200006D:
	RJMP _0x200006C
_0x200006E:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x200006F
	LDI  R18,LOW(48)
_0x200006B:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x2000070
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x4C
	CPI  R21,0
	BREQ _0x2000071
	SUBI R21,LOW(1)
_0x2000071:
_0x2000070:
_0x200006F:
_0x2000067:
	CALL SUBOPT_0x4A
	CPI  R21,0
	BREQ _0x2000072
	SUBI R21,LOW(1)
_0x2000072:
_0x200006C:
	SUBI R19,LOW(1)
	CALL SUBOPT_0x4F
	CALL __MODD21U
	__PUTD1S 12
	LDD  R30,Y+16
	__GETD2S 8
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __DIVD21U
	CALL SUBOPT_0x4E
	__GETD1S 8
	CALL __CPD10
	BREQ _0x2000061
	RJMP _0x2000060
_0x2000061:
_0x200005E:
	SBRS R16,0
	RJMP _0x2000073
_0x2000074:
	CPI  R21,0
	BREQ _0x2000076
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x4C
	RJMP _0x2000074
_0x2000076:
_0x2000073:
_0x2000077:
_0x2000033:
_0x20000CF:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+17
	LDD  R27,Y+17+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,25
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x50
	SBIW R30,0
	BRNE _0x2000078
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2080004
_0x2000078:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x50
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2080004:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG
_strlen:
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
	ST   -Y,R27
	ST   -Y,R26
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
_strncmpf:
	ST   -Y,R26
    clr  r0
    clr  r1
    ld   r22,y+
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
strncmpf0:
    tst  r22
    breq strncmpf1
    dec  r22
    ld   r1,x+
	lpm  r0,z+
    cp   r0,r1
    brne strncmpf1
    tst  r0
    brne strncmpf0
strncmpf3:
    clr  r30
    ret
strncmpf1:
    sub  r1,r0
    breq strncmpf3
    ldi  r30,1
    brcc strncmpf2
    subi r30,2
strncmpf2:
    ret
_strncpy:
	ST   -Y,R26
    ld   r23,y+
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strncpy0:
    tst  r23
    breq strncpy1
    dec  r23
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strncpy0
strncpy2:
    tst  r23
    breq strncpy1
    dec  r23
    st   x+,r22
    rjmp strncpy2
strncpy1:
    movw r30,r24
    ret
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G102:
	ST   -Y,R26
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2040004
	SBI  0x1B,3
	RJMP _0x2040005
_0x2040004:
	CBI  0x1B,3
_0x2040005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2040006
	SBI  0x1B,4
	RJMP _0x2040007
_0x2040006:
	CBI  0x1B,4
_0x2040007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2040008
	SBI  0x1B,5
	RJMP _0x2040009
_0x2040008:
	CBI  0x1B,5
_0x2040009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x204000A
	SBI  0x1B,6
	RJMP _0x204000B
_0x204000A:
	CBI  0x1B,6
_0x204000B:
	__DELAY_USB 5
	SBI  0x1B,2
	__DELAY_USB 13
	CBI  0x1B,2
	__DELAY_USB 13
	RJMP _0x2080001
__lcd_write_data:
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G102
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G102
	__DELAY_USB 133
	RJMP _0x2080001
_lcd_gotoxy:
	ST   -Y,R26
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G102)
	SBCI R31,HIGH(-__base_y_G102)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
_0x2080003:
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R26,LOW(2)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	CALL SUBOPT_0x2
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	CALL SUBOPT_0x2
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2040011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2040010
_0x2040011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R26,__lcd_y
	SUBI R26,-LOW(1)
	STS  __lcd_y,R26
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2040013
	RJMP _0x2080001
_0x2040013:
_0x2040010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	SBI  0x1B,0
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x1B,0
	RJMP _0x2080001
_lcd_puts:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2040014:
	CALL SUBOPT_0x3C
	BREQ _0x2040016
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2040014
_0x2040016:
	RJMP _0x2080002
_lcd_putsf:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2040017:
	CALL SUBOPT_0x3A
	BREQ _0x2040019
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2040017
_0x2040019:
_0x2080002:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_lcd_init:
	ST   -Y,R26
	SBI  0x1A,3
	SBI  0x1A,4
	SBI  0x1A,5
	SBI  0x1A,6
	SBI  0x1A,2
	SBI  0x1A,0
	SBI  0x1A,1
	CBI  0x1B,2
	CBI  0x1B,0
	CBI  0x1B,1
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G102,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G102,3
	LDI  R26,LOW(20)
	CALL SUBOPT_0x2
	CALL SUBOPT_0x51
	CALL SUBOPT_0x51
	CALL SUBOPT_0x51
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G102
	__DELAY_USW 200
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x2080001:
	ADIW R28,1
	RET

	.CSEG

	.DSEG
_temp_to_http_buffer:
	.BYTE 0x11
_pre_to_http_buffer:
	.BYTE 0x11
_mb:
	.BYTE 0x2
_md:
	.BYTE 0x2
_ac4:
	.BYTE 0x2
_ac5:
	.BYTE 0x2
_ac6:
	.BYTE 0x2
_mc:
	.BYTE 0x4
_UT:
	.BYTE 0x4
_UP:
	.BYTE 0x4
_T:
	.BYTE 0x4
_P:
	.BYTE 0x4
_x1:
	.BYTE 0x4
_x2:
	.BYTE 0x4
_x3:
	.BYTE 0x4
_b3:
	.BYTE 0x4
_b5:
	.BYTE 0x4
_b6:
	.BYTE 0x4
_b4:
	.BYTE 0x4
_b7:
	.BYTE 0x4
_data:
	.BYTE 0x2
_n1:
	.BYTE 0x2
_n2:
	.BYTE 0x2
_Enc28j60Bank_G000:
	.BYTE 0x1
_NextPacketPtr_G000:
	.BYTE 0x2
_eth_buf:
	.BYTE 0x401
_wwwport_G000:
	.BYTE 0x2
_udpport_G000:
	.BYTE 0x2
_macaddr_G000:
	.BYTE 0x6
_ipaddr_G000:
	.BYTE 0x4
_info_hdr_len_G000:
	.BYTE 0x2
_info_data_len_G000:
	.BYTE 0x2
_seqnum_G000:
	.BYTE 0x1
_mymac:
	.BYTE 0x6
_myip:
	.BYTE 0x4
_time_cs:
	.BYTE 0x1
_time_s:
	.BYTE 0x2
_counter1:
	.BYTE 0x2
_counter2:
	.BYTE 0x2
__base_y_G102:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	ST   -Y,R26
	CALL _i2c_start
	LDI  R26,LOW(238)
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:107 WORDS
SUBOPT_0x1:
	CALL _read_from_device
	LDS  R27,_data
	LDI  R26,LOW(0)
	__GETB1MN _data,1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x2:
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x3:
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x4:
	CALL __DIVD21
	STS  _x1,R30
	STS  _x1+1,R31
	STS  _x1+2,R22
	STS  _x1+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x5:
	LDS  R26,_x1
	LDS  R27,_x1+1
	LDS  R24,_x1+2
	LDS  R25,_x1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:57 WORDS
SUBOPT_0x6:
	CALL __DIVD21
	STS  _x2,R30
	STS  _x2+1,R31
	STS  _x2+2,R22
	STS  _x2+3,R23
	RCALL SUBOPT_0x5
	CALL __ADDD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	LDS  R30,_b5
	LDS  R31,_b5+1
	LDS  R22,_b5+2
	LDS  R23,_b5+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8:
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x10
	CALL __DIVD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x9:
	LDS  R26,_T
	LDS  R27,_T+1
	LDS  R24,_T+2
	LDS  R25,_T+3
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	CALL __DIVD21
	STS  _n1,R30
	STS  _n1+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	CALL __MODD21
	STS  _n2,R30
	STS  _n2+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xC:
	LDS  R30,_b6
	LDS  R31,_b6+1
	LDS  R22,_b6+2
	LDS  R23,_b6+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	LDS  R26,_b6
	LDS  R27,_b6+1
	LDS  R24,_b6+2
	LDS  R25,_b6+3
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xE:
	CALL __CWD2
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xF:
	STS  _x3,R30
	STS  _x3+1,R31
	STS  _x3+2,R22
	STS  _x3+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10:
	LDS  R30,_x3
	LDS  R31,_x3+1
	LDS  R22,_x3+2
	LDS  R23,_x3+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x4
	CALL __DIVD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	__GETD1N 0x10000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13:
	LDS  R26,_b7
	LDS  R27,_b7+1
	LDS  R24,_b7+2
	LDS  R25,_b7+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x14:
	LDS  R30,_b4
	LDS  R31,_b4+1
	LDS  R22,_b4+2
	LDS  R23,_b4+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x15:
	LDS  R26,_P
	LDS  R27,_P+1
	LDS  R24,_P+2
	LDS  R25,_P+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	RCALL SUBOPT_0x15
	__GETD1N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	CALL _enc28j60WriteOp
	LDI  R30,LOW(128)
	ST   -Y,R30
	LDI  R30,LOW(31)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x18:
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _enc28j60Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	ST   -Y,R30
	LDI  R26,LOW(25)
	JMP  _enc28j60Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1A:
	ST   -Y,R30
	LDI  R26,LOW(255)
	JMP  _enc28j60Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1B:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	ST   -Y,R30
	LDI  R30,LOW(31)
	ST   -Y,R30
	LDI  R26,LOW(8)
	JMP  _enc28j60WriteOp

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	ST   -Y,R30
	LDS  R30,_NextPacketPtr_G000+1
	MOV  R26,R30
	JMP  _enc28j60Write

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(58)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _enc28j60ReadOp

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	STS  _NextPacketPtr_G000,R30
	STS  _NextPacketPtr_G000+1,R31
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x20:
	CALL __GETD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x21:
	CALL __PUTD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x22:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SBIW R30,8
	CALL __GETD2S0
	CLR  R22
	CLR  R23
	CALL __ADDD12
	RJMP SUBOPT_0x21

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x23:
	CALL __GETD2S0
	CALL __ADDD12
	RJMP SUBOPT_0x21

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x24:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	LDI  R17,0
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x25:
	MOV  R30,R17
	LDI  R31,0
	MOVW R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x26:
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	MOVW R30,R0
	SUBI R30,LOW(-_ipaddr_G000)
	SBCI R31,HIGH(-_ipaddr_G000)
	LD   R30,Z
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x27:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	LDI  R17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x28:
	MOV  R30,R17
	LDI  R31,0
	MOVW R22,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x29:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R30,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x2A:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2B:
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2C:
	MOVW R30,R0
	SUBI R30,LOW(-_macaddr_G000)
	SBCI R31,HIGH(-_macaddr_G000)
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2D:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2E:
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2F:
	CALL _checksum
	MOVW R16,R30
	MOV  R30,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x30:
	MOVW R30,R0
	SUBI R30,LOW(-_ipaddr_G000)
	SBCI R31,HIGH(-_ipaddr_G000)
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x31:
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x32:
	ADIW R30,38
	SBIW R30,1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x33:
	ADIW R30,42
	SBIW R30,1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x34:
	CALL _make_eth
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(2)
	RJMP SUBOPT_0x2F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x36:
	__PUTB1SNS 2,50
	MOV  R30,R16
	__PUTB1SNS 2,51
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x37:
	STS  _info_data_len_G000,R30
	STS  _info_data_len_G000+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x38:
	LDS  R30,_info_data_len_G000
	LDS  R31,_info_data_len_G000+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x39:
	LDI  R31,0
	CALL __ASRW4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3A:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3B:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ADIW R30,1
	STD  Y+3,R30
	STD  Y+3+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3C:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3D:
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3E:
	LDI  R30,LOW(_eth_buf)
	LDI  R31,HIGH(_eth_buf)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3F:
	ANDI R31,HIGH(0x0)
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x40:
	ANDI R31,HIGH(0xFF)
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x41:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x42:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x43:
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x44:
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x45:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x46:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x47:
	LDI  R30,LOW(0)
	STS  _time_cs,R30
	STS  _time_s,R30
	STS  _time_s+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:46 WORDS
SUBOPT_0x48:
	CALL _concatstrf
	MOVW R16,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x49:
	CALL _concatstr
	MOVW R16,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x4A:
	ST   -Y,R18
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x4B:
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	SBIW R30,4
	STD  Y+21,R30
	STD  Y+21+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4C:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4D:
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4E:
	__PUTD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4F:
	__GETD1S 8
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x50:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x51:
	LDI  R26,LOW(48)
	CALL __lcd_write_nibble_G102
	__DELAY_USW 200
	RET


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2

_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	mov  r23,r26
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ldi  r23,8
__i2c_write0:
	lsl  r26
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ADDD21:
	ADD  R26,R30
	ADC  R27,R31
	ADC  R24,R22
	ADC  R25,R23
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ORD12:
	OR   R30,R26
	OR   R31,R27
	OR   R22,R24
	OR   R23,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__LSLD1:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	RET

__LSRD16:
	MOV  R30,R22
	MOV  R31,R23
	LDI  R22,0
	LDI  R23,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__MODD21:
	CLT
	SBRS R25,7
	RJMP __MODD211
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	SUBI R26,-1
	SBCI R27,-1
	SBCI R24,-1
	SBCI R25,-1
	SET
__MODD211:
	SBRC R23,7
	RCALL __ANEGD1
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	BRTC __MODD212
	RCALL __ANEGD1
__MODD212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
